using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Grouping;
using Syncfusion.Collections;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;

namespace ExtraRowHeader_GridGroupingControl
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			// GroupingEngineFactory provides a modified GridChildTable that adds an extra section
			GridEngineFactory.Factory = new GroupingEngineFactory();

			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridGroupingControl1
			// 
			this.gridGroupingControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
			this.gridGroupingControl1.Location = new System.Drawing.Point(32, 16);
			this.gridGroupingControl1.Name = "gridGroupingControl1";
			this.gridGroupingControl1.Size = new System.Drawing.Size(520, 424);
			this.gridGroupingControl1.TabIndex = 0;
			this.gridGroupingControl1.Text = "gridGroupingControl1";
			this.gridGroupingControl1.VersionInfo = "4.101.0.1";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(584, 454);
			this.Controls.Add(this.gridGroupingControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}


		private void Form1_Load(object sender, System.EventArgs e)
		{

			
			this.gridGroupingControl1.TableModel.Options.WrapCellBehavior = GridWrapCellBehavior.WrapRow;			
			
			this.gridGroupingControl1.DataSource = GetParentTable();
			this.gridGroupingControl1.ShowGroupDropArea = true;
			this.gridGroupingControl1.TopLevelGroupOptions.ShowCaption = false;
			this.gridGroupingControl1.QueryCellStyleInfo += new GridTableCellStyleInfoEventHandler(gridGroupingControl1_QueryCellStyleInfo);
			
			this.gridGroupingControl1.TableModel.CoveredRanges.Add(GridRangeInfo.Cells(1,1,1,3));   
			this.gridGroupingControl1.TableModel.CoveredRanges.Add(GridRangeInfo.Cells(1,4,1,6));   
			//this.gridGroupingControl1.TableModel.CoveredRanges.Add(GridRangeInfo.Cells(1,7,1,9));   


				
			
		}


		#region DataTable
		private int numberParentRows = 10;
		private DataTable GetParentTable()
		{
			DataTable dt = new DataTable("ParentTable");

			
			dt.Columns.Add(new DataColumn("parentID")); //lower case p
			dt.Columns.Add(new DataColumn("ParentName"));
			dt.Columns.Add(new DataColumn("ParentDec"));

			dt.Columns.Add(new DataColumn("CovedID")); //lower case p
			dt.Columns.Add(new DataColumn("CovedName"));
			dt.Columns.Add(new DataColumn("CovedDec"));

			dt.Columns.Add(new DataColumn("UnID")); //lower case p
			dt.Columns.Add(new DataColumn("UnName"));
			dt.Columns.Add(new DataColumn("UnDec"));


			for(int i = 0; i < numberParentRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i;//.ToString();
				dr[1] = string.Format("parentName{0}", i);
				dr[2] = string.Format("desc{0}", i);
				dt.Rows.Add(dr);
			}
			return dt;
		}
		#endregion

		

		private void gridGroupingControl1_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
		{
			e.Style.CellTipText = e.TableCellIdentity.Info;

			if (  e.TableCellIdentity.DisplayElement is ExtraSection)
			{
				if( e.TableCellIdentity.Table.TableModel.CoveredRanges.Ranges.AnyRangeIntersects(GridRangeInfo.Cell(e.TableCellIdentity.RowIndex,e.TableCellIdentity.ColIndex )) )
				{
					e.Style.CellType = "Header";
					e.Style.Text = "Covered"; 
					e.Style.HorizontalAlignment = GridHorizontalAlignment.Center;
  
				}
				else if( e.TableCellIdentity.ColIndex == 0 )
				{
					e.Style.CellType = "Header";
				}
				else
				{
					e.Style.CellType = "Static";
					e.Style.Borders.All = GridBorder.Empty;   
				}

			}
		}

		
	}
}
